blob: 5fbbf8c5d6a40b7d7709de39d10c08383c374600 [file] [log] [blame]
Benedikt Böhme2fa4912010-01-26 14:41:20 +01001#!/bin/sh
Benedikt Böhm00ccea62010-01-26 12:39:36 +01002#
Vincent Driessen6c2d30b2010-01-26 22:18:36 +01003# git-flow -- A collection of Git extensions to provide high-level
4# repository operations for Vincent Driessen's branching model.
Benedikt Böhm00ccea62010-01-26 12:39:36 +01005#
6# Original blog post presenting this model is found at:
7# http://nvie.com/archives/323
8#
9# Feel free to contribute to this project at:
10# http://github.com/nvie/gitflow
11#
12# Copyright (c) 2010 by Vincent Driessen
13# Copyright (c) 2010 by Benedikt Böhm
14#
15
Benedikt Böhme5eaff92010-01-26 12:44:55 +010016# enable debug mode
17if [ "$DEBUG" = "yes" ]; then
18 set -x
19fi
20
Benedikt Böhm4a864fb2010-01-26 12:59:27 +010021export GITFLOW_DIR=$(dirname "$0")
22export MASTER_BRANCH=$(git config --get gitflow.branch.master || echo master)
23export DEVELOP_BRANCH=$(git config --get gitflow.branch.develop || echo develop)
Benedikt Böhm350e7152010-01-26 13:05:05 +010024export ORIGIN=$(git config --get gitflow.origin || echo origin)
Benedikt Böhm427c5db2010-01-26 18:23:44 +010025export README=$(git config --get gitflow.readme || echo README)
Benedikt Böhm4a864fb2010-01-26 12:59:27 +010026
Benedikt Böhm00ccea62010-01-26 12:39:36 +010027warn() { echo "$@" >&2; }
28die() { warn "$@"; exit 1; }
Benedikt Böhme2fa4912010-01-26 14:41:20 +010029
30has() {
31 local item=$1; shift
32 echo " $@ " | grep -q " $item "
33}
Benedikt Böhm00ccea62010-01-26 12:39:36 +010034
35usage() {
Vincent Driessen186d2b52010-01-27 23:48:39 +010036 echo "usage: git flow <subcommand>"
Benedikt Böhm00ccea62010-01-26 12:39:36 +010037 echo
Vincent Driessen186d2b52010-01-27 23:48:39 +010038 echo "Available subcommands are:"
39 echo " init Initialize a new git repo with support for the branching model."
40 echo " feature Manage your feature branches."
41 echo " release Manage your release branches."
42 echo " hotfix Manage your hotfix branches."
43 echo " support Manage your support branches."
Vincent Driessen3625f392010-01-28 00:13:26 +010044 echo " version Shows version information."
Benedikt Böhm7d703a82010-01-26 13:17:12 +010045 echo
Vincent Driessen186d2b52010-01-27 23:48:39 +010046 echo "Try 'git flow <subcommand> help' for details."
Benedikt Böhm00ccea62010-01-26 12:39:36 +010047}
48
49main() {
Benedikt Böhm427c5db2010-01-26 18:23:44 +010050 if [ $# -lt 1 ]; then
Benedikt Böhm00ccea62010-01-26 12:39:36 +010051 usage
52 exit 1
53 fi
54
Benedikt Böhm00ccea62010-01-26 12:39:36 +010055 # sanity checks
Vincent Driessen186d2b52010-01-27 23:48:39 +010056 SUBCOMMAND="$1"; shift
Benedikt Böhm427c5db2010-01-26 18:23:44 +010057
Vincent Driessen186d2b52010-01-27 23:48:39 +010058 if [ ! -e "$GITFLOW_DIR/git-flow-$SUBCOMMAND" ]; then
Benedikt Böhm00ccea62010-01-26 12:39:36 +010059 usage
60 exit 1
61 fi
62
Vincent Driessen2ba9a4d2010-01-27 12:51:07 +010063 if ! git rev-parse --git-dir >/dev/null; then
Benedikt Böhm00ccea62010-01-26 12:39:36 +010064 die "Not a git repository"
65 fi
66
67 # get all available branches
68 LOCAL_BRANCHES=$(git branch | sed 's/^[* ] //')
69 REMOTE_BRANCHES=$(git branch -r | sed 's/^[* ] //')
70 ALL_BRANCHES="$LOCAL_BRANCHES $REMOTE_BRANCHES"
71
72 # run command
Vincent Driessen186d2b52010-01-27 23:48:39 +010073 . "$GITFLOW_DIR/git-flow-$SUBCOMMAND"
Benedikt Böhm00ccea62010-01-26 12:39:36 +010074
Vincent Driessen186d2b52010-01-27 23:48:39 +010075 SUBACTION="${1:-default}"; shift
76 if ! typeset -f cmd_$SUBACTION 2>&1 >/dev/null; then
77 warn "Unknown subcommand: '$1'"
78 usage
79 exit 1
Benedikt Böhm427c5db2010-01-26 18:23:44 +010080 fi
81
Vincent Driessen186d2b52010-01-27 23:48:39 +010082 # run the specified action
83 cmd_$SUBACTION "$@"
Benedikt Böhm427c5db2010-01-26 18:23:44 +010084}
85
Vincent Driessen48386442010-01-29 10:30:40 +010086gitflow_require_clean_working_tree() {
Benedikt Böhm00ccea62010-01-26 12:39:36 +010087 if ! git diff --no-ext-diff --ignore-submodules --quiet --exit-code; then
88 die "Working tree contains unstaged changes. Aborting ..."
89 fi
90 if ! git diff-index --cached --quiet --ignore-submodules HEAD --; then
91 die "Index contains uncommited changes. Aborting ..."
92 fi
93}
94
95gitflow_require_local_branch() {
96 if ! has $1 $LOCAL_BRANCHES; then
97 die "Local branch '$1' does not exist and is required."
98 fi
99}
100
101gitflow_require_remote_branch() {
102 if ! has $1 $REMOTE_BRANCHES; then
103 die "Remote branch '$1' does not exist and is required."
104 fi
105}
106
107gitflow_require_branch() {
108 if ! has $1 $ALL_BRANCHES; then
109 die "Branch '$1' does not exist and is required."
110 fi
111}
112
113gitflow_require_branch_absent() {
114 if has $1 $ALL_BRANCHES; then
115 die "Branch '$1' already exists. Pick another name."
116 fi
117}
118
119#
120# gitflow_test_branches_equal()
121#
122# Tests whether branches and their "origin" counterparts have diverged and need
123# merging first. It returns error codes to provide more detail, like so:
124#
125# 0 Branch heads point to the same commit
126# 1 First given branch needs fast-forwarding
127# 2 Second given branch needs fast-forwarding
128# 3 Branch needs a real merge
129#
130gitflow_test_branches_equal() {
131 commit1=$(git rev-parse "$1")
132 commit2=$(git rev-parse "$2")
133 if [ "$commit1" != "$commit2" ]; then
134 base=$(git merge-base "$commit1" "$commit2")
135 if [ "$commit1" = "$base" ]; then
136 return 1
137 elif [ "$commit2" = "$base" ]; then
138 return 2
139 else
140 return 3
141 fi
142 else
143 return 0
144 fi
145}
146
147gitflow_require_branches_equal() {
148 gitflow_require_local_branch "$1"
149 gitflow_require_remote_branch "$2"
150 gitflow_test_branches_equal "$1" "$2"
151 status=$?
152 if [ $status -gt 0 ]; then
153 warn "Branches '$1' and '$2' have diverged."
154 if [ $status -eq 1 ]; then
155 die "And branch '$1' may be fast-forwarded."
156 elif [ $status -eq 2 ]; then
157 # Warn here, since there is no harm in being ahead
158 warn "And local branch '$1' is ahead of '$2'."
159 else
160 die "Branches need merging first."
161 fi
162 fi
163}
164
165main "$@"